unit Jp100MainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ComCtrls, ExtCtrls, NewCtrls, SPIs;

type
  TJp100MainForm = class(TForm)
    HowSaveRadioGroup: TRadioGroup;
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    SaveFolderEdit: TEdit;
    SpeedButton1: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    FileDrop1: TFileDrop;
    ProgressBar: TProgressBar;
    SPIs: TSPIs;
    procedure FormCreate(Sender: TObject);
    procedure HowSaveRadioGroupClick(Sender: TObject);
    procedure FileDrop1FileDrop(Sender: TObject; Num: Integer; Files: TStrings;
      X, Y: Integer);
    procedure SPIsPictureRegister(Sender: TObject; ASPI: TInSPI;
      const AExtension, ADescription: string; var AGraphicClass: TGraphicClass);
    procedure SPIsSearch(Sender: TObject; ASPI: TSPI; var Accept: Boolean);
    procedure SPIsSearching(Sender: TObject; FileName: string;
      var Accept: Boolean);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormPaint(Sender: TObject);
  private
    { Private 錾 }
    IniFileName:string;
    procedure IniRead;
    procedure IniWrite;
    function GetSaveName(S:string):string;
  public
    { Public 錾 }
  end;

var
  Jp100MainForm: TJp100MainForm;

implementation

{$R *.dfm}

uses IniFiles,TSoft,
     Jpeg, GIFImg, pngimage,//WC[W
     SPINkDIB;

procedure TJp100MainForm.FileDrop1FileDrop(Sender: TObject; Num: Integer;
  Files: TStrings; X, Y: Integer);
var
  i:integer;
  FileName:string;
  FS:TFileStream;
  DIB:TSPINkDIB;
  TmpBmp:TBitmap;
  Jpg:TJPEGImage;
begin
  if (HowSaveRadioGroup.ItemIndex=2)and(not DirectoryExists(SaveFolderEdit.Text)) then
  begin
    MissMessBeep('ۑtH_w肵Ă');
    exit;
  end;

  ProgressBar.Max:=Num;
  for i:=0 to Num-1 do
  begin
    ProgressBar.Position:=i+1;
    Application.ProcessMessages;
    FileName:=Files[i];
//TSPINkDIB̂܂܂ƃATCłȂ
    TmpBmp:=TBitmap.Create;
    DIB:=TSPINkDIB.Create;
    try
      FS:=TFileStream.Create(FileName,fmOpenRead);
      try
        DIB.LoadFromStream(FS);
      finally
        FS.Free;
      end;
      Jpg:=TJPEGImage.Create;
      try
        TmpBmp.Assign(DIB);
        Jpg.Assign(TmpBmp);
        Jpg.SaveToFile(GetSaveName(FileName));
      finally
        TmpBmp.Free;
        Jpg.Free;
      end;
    finally
      DIB.Free;
    end;
  end;
  ProgressBar.Position:=0;
  SetForegroundWindowT(Handle);
end;

procedure TJp100MainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  IniWrite;
end;

procedure TJp100MainForm.FormCreate(Sender: TObject);
var
  i:integer;
begin
  Caption:='摜t@Chbv';
  IniFileName:=ChangeFileExt(Application.ExeName,'.ini');
  IniRead;
  with PageControl do
    for i := 0 to PageCount - 1 do
      Pages[i].TabVisible := False;
end;

procedure TJp100MainForm.FormPaint(Sender: TObject);
begin
  OnPaint:=nil;
  HowSaveRadioGroup.OnClick(HowSaveRadioGroup);
end;

function TJp100MainForm.GetSaveName(S: string): string;
var
  Path,
  JpgName:string;
begin
  Path:=ExtractFilePath(S);
  JpgName:=ChangeFileExt(ExtractFileName(S),'.jpg');
  case HowSaveRadioGroup.ItemIndex of
    0:begin
        repeat
          JpgName:='_'+JpgName;
          Result:=Path+JpgName;
        until not FileExists(Result);
      end;
    1:Result:=Path+JpgName;
    2:begin
        Result:=IncludeTrailingPathDelimiter(SaveFolderEdit.Text)+JpgName;
      end;
  else ;
  end;
end;

procedure TJp100MainForm.IniRead;
begin
  with TMemIniFile.Create(IniFileName) do
  begin
    try
      Top:=ReadInteger('Window','Top',0);
      Left:=ReadInteger('Window','Left',0);
      if (Screen.DesktopWidth-10<Left)or(-(Width-10)>Left) then Left:=0;
      if (Screen.DesktopHeight-10<Top)or(-(Height-10)>Top) then Top:=0;
      HowSaveRadioGroup.ItemIndex:=ReadInteger('Config','HowSave',HowSaveRadioGroup.ItemIndex);

    finally
      Free;
    end;
  end;
end;

procedure TJp100MainForm.IniWrite;
begin
  with TMemIniFile.Create(IniFileName) do
  begin
    try
      WriteInteger('Window','Top',Top);
      WriteInteger('Window','Left',Left);
      WriteInteger('Config','HowSave',HowSaveRadioGroup.ItemIndex);

    finally
      UpdateFile;
      Free;
    end;
  end;
end;

procedure TJp100MainForm.SpeedButton1Click(Sender: TObject);
var
  Dir:string;
begin
  Dir:=OpenFolder(SaveFolderEdit.Text,'ۑ̑I',Handle,True);
  if Dir<>'' then SaveFolderEdit.Text:=Dir;
end;

procedure TJp100MainForm.SPIsPictureRegister(Sender: TObject; ASPI: TInSPI;
  const AExtension, ADescription: string; var AGraphicClass: TGraphicClass);
var
  Ext:string;
begin
  AGraphicClass := TSPINkDIB;
  Ext:=UpperCase(AExtension);
  if (Ext='JPG') or(Ext='JPEG')or
     (Ext='ICO') or(Ext='BMP')or
        (Ext='PNG') or(Ext='GIF') then
  begin
    AGraphicClass := nil;
  end;
end;

procedure TJp100MainForm.SPIsSearch(Sender: TObject; ASPI: TSPI;
  var Accept: Boolean);
begin
  Accept := ASPI is TInSPI;
end;

procedure TJp100MainForm.SPIsSearching(Sender: TObject; FileName: string;
  var Accept: Boolean);
begin
//IFHG.SPI Ȃǈꕔ SPI ͓ǂݍ܂Ȃ
  if (CompareText(ExtractFileName(FileName), 'IFHG.SPI') = 0)or
     (CompareText(ExtractFileName(FileName), 'IFBMP.SPI') = 0)or
     (CompareText(ExtractFileName(FileName), 'IFGIF.SPI') = 0)or
     (CompareText(ExtractFileName(FileName), 'ifply.spi') = 0)or
//     (CompareText(ExtractFileName(FileName), 'IFICON.SPI') = 0)or//http%3A%2F%2Fcoverswww2.met-art.com%2Ffavicon.ico ŃG[H
     (CompareText(ExtractFileName(FileName), 'if3ds.spi') = 0)or//ȉ摜Ōł܂
     (CompareText(ExtractFileName(FileName), 'IFMM.SPI') = 0) then
  begin
    Accept := False;
  end;
end;

procedure TJp100MainForm.HowSaveRadioGroupClick(Sender: TObject);
begin
  PageControl.ActivePageIndex:=(Sender as TRadioGroup).ItemIndex;
end;

end.
